(function(){var CR_NEWLINE_R=/\r\n?/g;var TAB_R=/\t/g;var FORMFEED_R=/\f/g;var preprocess=function(source){return source.replace(CR_NEWLINE_R,"\n").replace(FORMFEED_R,"").replace(TAB_R,"    ")};var populateInitialState=function(givenState,defaultState){var state=givenState||{};if(defaultState!=null){for(var prop in defaultState){if(Object.prototype.hasOwnProperty.call(defaultState,prop)){state[prop]=defaultState[prop]}}}return state};var parserFor=function(rules,defaultState){var ruleList=Object.keys(rules).filter(function(type){var rule=rules[type];if(rule==null||rule.match==null){return false}var order=rule.order;if((typeof order!=="number"||!isFinite(order))&&typeof console!=="undefined"){console.warn("simple-markdown: Invalid order for rule `"+type+"`: "+String(order))}return true});ruleList.sort(function(typeA,typeB){var ruleA=rules[typeA];var ruleB=rules[typeB];var orderA=ruleA.order;var orderB=ruleB.order;if(orderA!==orderB){return orderA-orderB}var secondaryOrderA=ruleA.quality?0:1;var secondaryOrderB=ruleB.quality?0:1;if(secondaryOrderA!==secondaryOrderB){return secondaryOrderA-secondaryOrderB}else if(typeA<typeB){return-1}else if(typeA>typeB){return 1}else{return 0}});var latestState;var nestedParse=function(source,state){var result=[];state=state||latestState;latestState=state;var prevCapture="";while(source){var ruleType=null;var rule=null;var capture=null;var quality=NaN;var i=0;var currRuleType=ruleList[0];var currRule=rules[currRuleType];do{var currOrder=currRule.order;var currCapture=currRule.match(source,state,prevCapture);if(currCapture){var currQuality=currRule.quality?currRule.quality(currCapture,state,prevCapture):0;if(!(currQuality<=quality)){ruleType=currRuleType;rule=currRule;capture=currCapture;quality=currQuality}}i++;currRuleType=ruleList[i];currRule=rules[currRuleType]}while(currRule&&(!capture||currRule.order===currOrder&&currRule.quality));if(state.disableErrorGuards!==true){if(rule==null||capture==null){throw new Error("Could not find a matching rule for the below "+"content. The rule with highest `order` should "+"always match content provided to it. Check "+"the definition of `match` for '"+ruleList[ruleList.length-1]+"'. It seems to not match the following source:\n"+source)}if(capture.index!==0&&source.slice(0,capture[0].length)!==capture[0]){throw new Error("`match` must return a capture starting at index 0 "+"(the current parse index). Did you forget a ^ at the "+"start of the RegExp?")}}var parsed=rule.parse(capture,nestedParse,state);if(Array.isArray(parsed)){Array.prototype.push.apply(result,parsed)}else{if(parsed.type==null){parsed.type=ruleType}result.push(parsed)}prevCapture=capture[0];source=source.substring(prevCapture.length)}return result};var outerParse=function(source,state){latestState=populateInitialState(state,defaultState);if(!latestState.inline&&!latestState.disableAutoBlockNewlines){source=source+"\n\n"}return nestedParse(preprocess(source),latestState)};return outerParse};var inlineRegex=function(regex){var match=function(source,state){if(state.inline){return regex.exec(source)}else{return null}};match.regex=regex;return match};var blockRegex=function(regex){var match=function(source,state){if(state.inline){return null}else{return regex.exec(source)}};match.regex=regex;return match};var anyScopeRegex=function(regex){var match=function(source,state){return regex.exec(source)};match.regex=regex;return match};var TYPE_SYMBOL=typeof Symbol==="function"&&Symbol.for&&Symbol.for("react.element")||60103;var reactElement=function(type,key,props){var element={$$typeof:TYPE_SYMBOL,type:type,key:key,ref:null,props:props,_owner:null};return element};var htmlTag=function(tagName,content,attributes,isClosed){attributes=attributes||{};isClosed=typeof isClosed!=="undefined"?isClosed:true;var attributeString="";for(var attr in attributes){var attribute=attributes[attr];if(Object.prototype.hasOwnProperty.call(attributes,attr)&&attribute){attributeString+=" "+sanitizeText(attr)+'="'+sanitizeText(attribute)+'"'}}var unclosedTag="<"+tagName+attributeString+">";if(isClosed){return unclosedTag+content+"</"+tagName+">"}else{return unclosedTag}};var EMPTY_PROPS={};var sanitizeUrl=function(url){if(url==null){return null}try{var prot=decodeURIComponent(url).replace(/[^A-Za-z0-9/:]/g,"").toLowerCase();if(prot.indexOf("javascript:")===0){return null}}catch(e){return null}return url};var SANITIZE_TEXT_R=/[<>&"']/g;var SANITIZE_TEXT_CODES={"<":"&lt;",">":"&gt;","&":"&amp;",'"':"&quot;","'":"&#x27;","/":"&#x2F;","`":"&#96;"};var sanitizeText=function(text){return String(text).replace(SANITIZE_TEXT_R,function(chr){return SANITIZE_TEXT_CODES[chr]})};var UNESCAPE_URL_R=/\\([^0-9A-Za-z\s])/g;var unescapeUrl=function(rawUrlString){return rawUrlString.replace(UNESCAPE_URL_R,"$1")};var parseInline=function(parse,content,state){var isCurrentlyInline=state.inline||false;state.inline=true;var result=parse(content,state);state.inline=isCurrentlyInline;return result};var parseBlock=function(parse,content,state){var isCurrentlyInline=state.inline||false;state.inline=false;var result=parse(content+"\n\n",state);state.inline=isCurrentlyInline;return result};var parseCaptureInline=function(capture,parse,state){return{content:parseInline(parse,capture[1],state)}};var ignoreCapture=function(){return{}};var LIST_BULLET="(?:[*+-]|\\d+\\.)";var LIST_ITEM_PREFIX="( *)("+LIST_BULLET+") +";var LIST_ITEM_PREFIX_R=new RegExp("^"+LIST_ITEM_PREFIX);var LIST_ITEM_R=new RegExp(LIST_ITEM_PREFIX+"[^\\n]*(?:\\n"+"(?!\\1"+LIST_BULLET+" )[^\\n]*)*(\n|$)","gm");var BLOCK_END_R=/\n{2,}$/;var LIST_BLOCK_END_R=BLOCK_END_R;var LIST_ITEM_END_R=/ *\n+$/;var LIST_R=new RegExp("^( *)("+LIST_BULLET+") "+"[\\s\\S]+?(?:\n{2,}(?! )"+"(?!\\1"+LIST_BULLET+" )\\n*"+"|\\s*\n*$)");var LIST_LOOKBEHIND_R=/(?:^|\n)( *)$/;var TABLES=function(){var TABLE_HEADER_TRIM=/^ *| *\| *$/g;var TABLE_CELLS_TRIM=/\n+$/;var PLAIN_TABLE_ROW_TRIM=/^ *\| *| *\| *$/g;var NPTABLE_ROW_TRIM=/^ *| *$/g;var TABLE_ROW_SPLIT=/ *\| */;var TABLE_RIGHT_ALIGN=/^ *-+: *$/;var TABLE_CENTER_ALIGN=/^ *:-+: *$/;var TABLE_LEFT_ALIGN=/^ *:-+ *$/;var parseTableAlignCapture=function(alignCapture){if(TABLE_RIGHT_ALIGN.test(alignCapture)){return"right"}else if(TABLE_CENTER_ALIGN.test(alignCapture)){return"center"}else if(TABLE_LEFT_ALIGN.test(alignCapture)){return"left"}else{return null}};var parseTableHeader=function(trimRegex,capture,parse,state){var headerText=capture[1].replace(trimRegex,"").split(TABLE_ROW_SPLIT);return headerText.map(function(text){return parse(text,state)})};var parseTableAlign=function(trimRegex,capture,parse,state){var alignText=capture[2].replace(trimRegex,"").split(TABLE_ROW_SPLIT);return alignText.map(parseTableAlignCapture)};var parseTableCells=function(capture,parse,state){var rowsText=capture[3].replace(TABLE_CELLS_TRIM,"").split("\n");return rowsText.map(function(rowText){var cellText=rowText.replace(PLAIN_TABLE_ROW_TRIM,"").split(TABLE_ROW_SPLIT);return cellText.map(function(text){return parse(text,state)})})};var parseNpTableCells=function(capture,parse,state){var rowsText=capture[3].replace(TABLE_CELLS_TRIM,"").split("\n");return rowsText.map(function(rowText){var cellText=rowText.split(TABLE_ROW_SPLIT);return cellText.map(function(text){return parse(text,state)})})};var parseTable=function(capture,parse,state){state.inline=true;var header=parseTableHeader(TABLE_HEADER_TRIM,capture,parse,state);var align=parseTableAlign(TABLE_HEADER_TRIM,capture,parse,state);var cells=parseTableCells(capture,parse,state);state.inline=false;return{type:"table",header:header,align:align,cells:cells}};var parseNpTable=function(capture,parse,state){state.inline=true;var header=parseTableHeader(NPTABLE_ROW_TRIM,capture,parse,state);var align=parseTableAlign(NPTABLE_ROW_TRIM,capture,parse,state);var cells=parseNpTableCells(capture,parse,state);state.inline=false;return{type:"table",header:header,align:align,cells:cells}};return{parseTable:parseTable,parseNpTable:parseNpTable,NPTABLE_REGEX:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/}}();var LINK_INSIDE="(?:\\[[^\\]]*\\]|[^\\[\\]]|\\](?=[^\\[]*\\]))*";var LINK_HREF_AND_TITLE="\\s*<?((?:[^\\s\\\\]|\\\\.)*?)>?(?:\\s+['\"]([\\s\\S]*?)['\"])?\\s*";var AUTOLINK_MAILTO_CHECK_R=/mailto:/i;var parseRef=function(capture,state,refNode){var ref=(capture[2]||capture[1]).replace(/\s+/g," ").toLowerCase();if(state._defs&&state._defs[ref]){var def=state._defs[ref];refNode.target=def.target;refNode.title=def.title}state._refs=state._refs||{};state._refs[ref]=state._refs[ref]||[];state._refs[ref].push(refNode);return refNode};var currOrder=0;var defaultRules={Array:{react:function(arr,output,state){var oldKey=state.key;var result=[];for(var i=0,key=0;i<arr.length;i++,key++){state.key=""+i;var node=arr[i];if(node.type==="text"){node={type:"text",content:node.content};for(;i+1<arr.length&&arr[i+1].type==="text";i++){node.content+=arr[i+1].content}}result.push(output(node,state))}state.key=oldKey;return result},html:function(arr,output,state){var result="";for(var i=0,key=0;i<arr.length;i++){var node=arr[i];if(node.type==="text"){node={type:"text",content:node.content};for(;i+1<arr.length&&arr[i+1].type==="text";i++){node.content+=arr[i+1].content}}result+=output(node,state)}return result}},heading:{order:currOrder++,match:blockRegex(/^ *(#{1,6}) *([^\n]+?) *#* *(?:\n *)+\n/),parse:function(capture,parse,state){return{level:capture[1].length,content:parseInline(parse,capture[2],state)}},react:function(node,output,state){return reactElement("h"+node.level,state.key,{children:output(node.content,state)})},html:function(node,output,state){return htmlTag("h"+node.level,output(node.content,state))}},nptable:{order:currOrder++,match:blockRegex(TABLES.NPTABLE_REGEX),parse:TABLES.parseNpTable,react:null,html:null},lheading:{order:currOrder++,match:blockRegex(/^([^\n]+)\n *(=|-){3,} *(?:\n *)+\n/),parse:function(capture,parse,state){return{type:"heading",level:capture[2]==="="?1:2,content:parseInline(parse,capture[1],state)}},react:null,html:null},hr:{order:currOrder++,match:blockRegex(/^( *[-*_]){3,} *(?:\n *)+\n/),parse:ignoreCapture,react:function(node,output,state){return reactElement("hr",state.key,EMPTY_PROPS)},html:function(node,output,state){return"<hr>"}},codeBlock:{order:currOrder++,match:blockRegex(/^(?:    [^\n]+\n*)+(?:\n *)+\n/),parse:function(capture,parse,state){var content=capture[0].replace(/^    /gm,"").replace(/\n+$/,"");return{lang:undefined,content:content}},react:function(node,output,state){var className=node.lang?"markdown-code-"+node.lang:undefined;return reactElement("pre",state.key,{children:reactElement("code",null,{className:className,children:node.content})})},html:function(node,output,state){var className=node.lang?"markdown-code-"+node.lang:undefined;var codeBlock=htmlTag("code",sanitizeText(node.content),{class:className});return htmlTag("pre",codeBlock)}},fence:{order:currOrder++,match:blockRegex(/^ *(`{3,}|~{3,}) *(\S+)? *\n([\s\S]+?)\s*\1 *(?:\n *)+\n/),parse:function(capture,parse,state){return{type:"codeBlock",lang:capture[2]||undefined,content:capture[3]}},react:null,html:null},blockQuote:{order:currOrder++,match:blockRegex(/^( *>[^\n]+(\n[^\n]+)*\n*)+\n{2,}/),parse:function(capture,parse,state){var content=capture[0].replace(/^ *> ?/gm,"");return{content:parse(content,state)}},react:function(node,output,state){return reactElement("blockquote",state.key,{children:output(node.content,state)})},html:function(node,output,state){return htmlTag("blockquote",output(node.content,state))}},list:{order:currOrder++,match:function(source,state,prevCapture){var isStartOfLineCapture=LIST_LOOKBEHIND_R.exec(prevCapture);var isListBlock=state._list||!state.inline;if(isStartOfLineCapture&&isListBlock){source=isStartOfLineCapture[1]+source;var res=LIST_R.exec(source);return LIST_R.exec(source)}else{return null}},parse:function(capture,parse,state){var bullet=capture[2];var ordered=bullet.length>1;var start=ordered?+bullet:undefined;var items=capture[0].replace(LIST_BLOCK_END_R,"\n").match(LIST_ITEM_R);var lastItemWasAParagraph=false;var itemContent=items.map(function(item,i){var space=LIST_ITEM_PREFIX_R.exec(item)[0].length;var spaceRegex=new RegExp("^ {1,"+space+"}","gm");var content=item.replace(spaceRegex,"").replace(LIST_ITEM_PREFIX_R,"");var isLastItem=i===items.length-1;var containsBlocks=content.indexOf("\n\n")!==-1;var thisItemIsAParagraph=containsBlocks||isLastItem&&lastItemWasAParagraph;lastItemWasAParagraph=thisItemIsAParagraph;var oldStateInline=state.inline;var oldStateList=state._list;state._list=true;var adjustedContent;if(thisItemIsAParagraph){state.inline=false;adjustedContent=content.replace(LIST_ITEM_END_R,"\n\n")}else{state.inline=true;adjustedContent=content.replace(LIST_ITEM_END_R,"")}var result=parse(adjustedContent,state);state.inline=oldStateInline;state._list=oldStateList;return result});return{ordered:ordered,start:start,items:itemContent}},react:function(node,output,state){var ListWrapper=node.ordered?"ol":"ul";return reactElement(ListWrapper,state.key,{start:node.start,children:node.items.map(function(item,i){return reactElement("li",""+i,{children:output(item,state)})})})},html:function(node,output,state){var listItems=node.items.map(function(item){return htmlTag("li",output(item,state))}).join("");var listTag=node.ordered?"ol":"ul";var attributes={start:node.start};return htmlTag(listTag,listItems,attributes)}},def:{order:currOrder++,match:blockRegex(/^ *\[([^\]]+)\]: *<?([^\s>]*)>?(?: +["(]([^\n]+)[")])? *\n(?: *\n)*/),parse:function(capture,parse,state){var def=capture[1].replace(/\s+/g," ").toLowerCase();var target=capture[2];var title=capture[3];if(state._refs&&state._refs[def]){state._refs[def].forEach(function(refNode){refNode.target=target;refNode.title=title})}state._defs=state._defs||{};state._defs[def]={target:target,title:title};return{def:def,target:target,title:title}},react:function(){return null},html:function(){return""}},table:{order:currOrder++,match:blockRegex(/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/),parse:TABLES.parseTable,react:function(node,output,state){var getStyle=function(colIndex){return node.align[colIndex]==null?{}:{textAlign:node.align[colIndex]}};var headers=node.header.map(function(content,i){return reactElement("th",""+i,{style:getStyle(i),scope:"col",children:output(content,state)})});var rows=node.cells.map(function(row,r){return reactElement("tr",""+r,{children:row.map(function(content,c){return reactElement("td",""+c,{style:getStyle(c),children:output(content,state)})})})});return reactElement("table",state.key,{children:[reactElement("thead","thead",{children:reactElement("tr",null,{children:headers})}),reactElement("tbody","tbody",{children:rows})]})},html:function(node,output,state){var getStyle=function(colIndex){return node.align[colIndex]==null?"":"text-align:"+node.align[colIndex]+";"};var headers=node.header.map(function(content,i){return htmlTag("th",output(content,state),{style:getStyle(i),scope:"col"})}).join("");var rows=node.cells.map(function(row){var cols=row.map(function(content,c){return htmlTag("td",output(content,state),{style:getStyle(c)})}).join("");return htmlTag("tr",cols)}).join("");var thead=htmlTag("thead",htmlTag("tr",headers));var tbody=htmlTag("tbody",rows);return htmlTag("table",thead+tbody)}},newline:{order:currOrder++,match:blockRegex(/^(?:\n *)*\n/),parse:ignoreCapture,react:function(node,output,state){return"\n"},html:function(node,output,state){return"\n"}},paragraph:{order:currOrder++,match:blockRegex(/^((?:[^\n]|\n(?! *\n))+)(?:\n *)+\n/),parse:parseCaptureInline,react:function(node,output,state){return reactElement("div",state.key,{className:"paragraph",children:output(node.content,state)})},html:function(node,output,state){var attributes={class:"paragraph"};return htmlTag("div",output(node.content,state),attributes)}},escape:{order:currOrder++,match:inlineRegex(/^\\([^0-9A-Za-z\s])/),parse:function(capture,parse,state){return{type:"text",content:capture[1]}},react:null,html:null},autolink:{order:currOrder++,match:inlineRegex(/^<([^ >]+:\/[^ >]+)>/),parse:function(capture,parse,state){return{type:"link",content:[{type:"text",content:capture[1]}],target:capture[1]}},react:null,html:null},mailto:{order:currOrder++,match:inlineRegex(/^<([^ >]+@[^ >]+)>/),parse:function(capture,parse,state){var address=capture[1];var target=capture[1];if(!AUTOLINK_MAILTO_CHECK_R.test(target)){target="mailto:"+target}return{type:"link",content:[{type:"text",content:address}],target:target}},react:null,html:null},url:{order:currOrder++,match:inlineRegex(/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/),parse:function(capture,parse,state){return{type:"link",content:[{type:"text",content:capture[1]}],target:capture[1],title:undefined}},react:null,html:null},link:{order:currOrder++,match:inlineRegex(new RegExp("^\\[("+LINK_INSIDE+")\\]\\("+LINK_HREF_AND_TITLE+"\\)")),parse:function(capture,parse,state){var link={content:parse(capture[1],state),target:unescapeUrl(capture[2]),title:capture[3]};return link},react:function(node,output,state){return reactElement("a",state.key,{href:sanitizeUrl(node.target),title:node.title,children:output(node.content,state)})},html:function(node,output,state){var attributes={href:sanitizeUrl(node.target),title:node.title};return htmlTag("a",output(node.content,state),attributes)}},image:{order:currOrder++,match:inlineRegex(new RegExp("^!\\[("+LINK_INSIDE+")\\]\\("+LINK_HREF_AND_TITLE+"\\)")),parse:function(capture,parse,state){var image={alt:capture[1],target:unescapeUrl(capture[2]),title:capture[3]};return image},react:function(node,output,state){return reactElement("img",state.key,{src:sanitizeUrl(node.target),alt:node.alt,title:node.title})},html:function(node,output,state){var attributes={src:sanitizeUrl(node.target),alt:node.alt,title:node.title};return htmlTag("img","",attributes,false)}},reflink:{order:currOrder++,match:inlineRegex(new RegExp("^\\[("+LINK_INSIDE+")\\]"+"\\s*\\[([^\\]]*)\\]")),parse:function(capture,parse,state){return parseRef(capture,state,{type:"link",content:parse(capture[1],state)})},react:null,html:null},refimage:{order:currOrder++,match:inlineRegex(new RegExp("^!\\[("+LINK_INSIDE+")\\]"+"\\s*\\[([^\\]]*)\\]")),parse:function(capture,parse,state){return parseRef(capture,state,{type:"image",alt:capture[1]})},react:null,html:null},em:{order:currOrder,match:inlineRegex(new RegExp("^\\b_"+"((?:__|\\\\[\\s\\S]|[^\\\\_])+?)_"+"\\b"+"|"+"^\\*(?=\\S)("+"(?:"+"\\*\\*|"+"\\\\[\\s\\S]|"+"\\s+(?:\\\\[\\s\\S]|[^\\s\\*\\\\]|\\*\\*)|"+"[^\\s\\*\\\\]"+")+?"+")\\*(?!\\*)")),quality:function(capture){return capture[0].length+.2},parse:function(capture,parse,state){return{content:parse(capture[2]||capture[1],state)}},react:function(node,output,state){return reactElement("em",state.key,{children:output(node.content,state)})},html:function(node,output,state){return htmlTag("em",output(node.content,state))}},strong:{order:currOrder,match:inlineRegex(/^\*\*((?:\\[\s\S]|[^\\])+?)\*\*(?!\*)/),quality:function(capture){return capture[0].length+.1},parse:parseCaptureInline,react:function(node,output,state){return reactElement("strong",state.key,{children:output(node.content,state)})},html:function(node,output,state){return htmlTag("strong",output(node.content,state))}},u:{order:currOrder++,match:inlineRegex(/^__([\s\S]+?)__(?!_)/),quality:function(capture){return capture[0].length},parse:parseCaptureInline,react:function(node,output,state){return reactElement("u",state.key,{children:output(node.content,state)})},html:function(node,output,state){return htmlTag("u",output(node.content,state))}},del:{order:currOrder++,match:inlineRegex(/^~~(?=\S)([\s\S]*?\S)~~/),parse:parseCaptureInline,react:function(node,output,state){return reactElement("del",state.key,{children:output(node.content,state)})},html:function(node,output,state){return htmlTag("del",output(node.content,state))}},inlineCode:{order:currOrder++,match:inlineRegex(/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/),parse:function(capture,parse,state){return{content:capture[2]}},react:function(node,output,state){return reactElement("code",state.key,{children:node.content})},html:function(node,output,state){return htmlTag("code",sanitizeText(node.content))}},br:{order:currOrder++,match:anyScopeRegex(/^ {2,}\n/),parse:ignoreCapture,react:function(node,output,state){return reactElement("br",state.key,EMPTY_PROPS)},html:function(node,output,state){return"<br>"}},text:{order:currOrder++,match:anyScopeRegex(/^[\s\S]+?(?=[^0-9A-Za-z\s\u00c0-\uffff]|\n\n| {2,}\n|\w+:\S|$)/),parse:function(capture,parse,state){return{content:capture[0]}},react:function(node,output,state){return node.content},html:function(node,output,state){return sanitizeText(node.content)}}};var ruleOutput=function(rules,property){if(!property&&typeof console!=="undefined"){console.warn("simple-markdown ruleOutput should take 'react' or "+"'html' as the second argument.")}var nestedRuleOutput=function(ast,outputFunc,state){return rules[ast.type][property](ast,outputFunc,state)};return nestedRuleOutput};var reactFor=function(outputFunc){var nestedOutput=function(ast,state){state=state||{};if(Array.isArray(ast)){var oldKey=state.key;var result=[];var lastResult=null;for(var i=0;i<ast.length;i++){state.key=""+i;var nodeOut=nestedOutput(ast[i],state);if(typeof nodeOut==="string"&&typeof lastResult==="string"){lastResult=lastResult+nodeOut;result[result.length-1]=lastResult}else{result.push(nodeOut);lastResult=nodeOut}}state.key=oldKey;return result}else{return outputFunc(ast,nestedOutput,state)}};return nestedOutput};var htmlFor=function(outputFunc){var nestedOutput=function(ast,state){state=state||{};if(Array.isArray(ast)){return ast.map(function(node){return nestedOutput(node,state)}).join("")}else{return outputFunc(ast,nestedOutput,state)}};return nestedOutput};var outputFor=function(rules,property,defaultState){if(!property){throw new Error("simple-markdown: outputFor: `property` must be "+"defined. "+"if you just upgraded, you probably need to replace `outputFor` "+"with `reactFor`")}var latestState;var arrayRule=rules.Array||defaultRules.Array;var nestedOutput=function(ast,state){state=state||latestState;latestState=state;if(Array.isArray(ast)){return arrayRule[property](ast,nestedOutput,state)}else{return rules[ast.type][property](ast,nestedOutput,state)}};var outerOutput=function(ast,state){latestState=populateInitialState(state,defaultState);return nestedOutput(ast,latestState)};return outerOutput};var defaultRawParse=parserFor(defaultRules);var defaultBlockParse=function(source,state){state=state||{};state.inline=false;return defaultRawParse(source,state)};var defaultInlineParse=function(source,state){state=state||{};state.inline=true;return defaultRawParse(source,state)};var defaultImplicitParse=function(source,state){var isBlock=BLOCK_END_R.test(source);state=state||{};state.inline=!isBlock;return defaultRawParse(source,state)};var defaultReactOutput=outputFor(defaultRules,"react");var defaultHtmlOutput=outputFor(defaultRules,"html");var markdownToReact=function(source,state){return defaultReactOutput(defaultBlockParse(source,state),state)};var markdownToHtml=function(source,state){return defaultHtmlOutput(defaultBlockParse(source,state),state)};var ReactMarkdown=function(props){var divProps={};for(var prop in props){if(prop!=="source"&&Object.prototype.hasOwnProperty.call(props,prop)){divProps[prop]=props[prop]}}divProps.children=markdownToReact(props.source);return reactElement("div",null,divProps)};var SimpleMarkdown={defaultRules:defaultRules,parserFor:parserFor,outputFor:outputFor,inlineRegex:inlineRegex,blockRegex:blockRegex,anyScopeRegex:anyScopeRegex,parseInline:parseInline,parseBlock:parseBlock,markdownToReact:markdownToReact,markdownToHtml:markdownToHtml,ReactMarkdown:ReactMarkdown,defaultBlockParse:defaultBlockParse,defaultInlineParse:defaultInlineParse,defaultImplicitParse:defaultImplicitParse,defaultReactOutput:defaultReactOutput,defaultHtmlOutput:defaultHtmlOutput,preprocess:preprocess,sanitizeText:sanitizeText,sanitizeUrl:sanitizeUrl,unescapeUrl:unescapeUrl,htmlTag:htmlTag,reactElement:reactElement,defaultRawParse:defaultRawParse,ruleOutput:ruleOutput,reactFor:reactFor,htmlFor:htmlFor,defaultParse:function(){if(typeof console!=="undefined"){console.warn("defaultParse is deprecated, please use `defaultImplicitParse`")}return defaultImplicitParse.apply(null,arguments)},defaultOutput:function(){if(typeof console!=="undefined"){console.warn("defaultOutput is deprecated, please use `defaultReactOutput`")}return defaultReactOutput.apply(null,arguments)}};if(typeof module!=="undefined"&&module.exports){module.exports=SimpleMarkdown}else if(typeof global!=="undefined"){global.SimpleMarkdown=SimpleMarkdown}else{window.SimpleMarkdown=SimpleMarkdown}})();